﻿Imports System.ComponentModel
Imports System.Security.Principal

Public Class UserData
    Public Property UserName() As String
    Public Property MyName() As String
    Public Property Email() As String
    Public Property IsAdmin() As Boolean

    <DataObjectMethod(DataObjectMethodType.Select, True)>
    Public Function GetAllUserData() As List(Of UserData)
        Dim data As New List(Of UserData)
        Dim users As MembershipUserCollection = Membership.GetAllUsers()
        For Each user As MembershipUser In users
            Dim datum As New UserData()
            datum.UserName = user.UserName
            datum.MyName = ProfileBase.Create(user.UserName).GetPropertyValue("MyName")
            datum.Email = user.Email
            datum.IsAdmin = Roles.IsUserInRole(user.UserName, "Admin")
            data.Add(datum)
        Next
        Return data
    End Function

    <DataObjectMethod(DataObjectMethodType.Update, True)>
    Public Sub UpdateUserData(ByVal user As UserData)
        Dim curUser As MembershipUser = Membership.GetUser(user.UserName)
        curUser.Email = user.Email
        Membership.UpdateUser(curUser)
        Dim prof As ProfileBase = ProfileBase.Create(user.UserName)
        prof.SetPropertyValue("MyName", user.MyName)
        prof.Save()
        Dim bAdmin As Boolean = Roles.IsUserInRole(user.UserName, "Admin")
        If (Not bAdmin) And user.IsAdmin Then Roles.AddUserToRole(user.UserName, "Admin")
        If bAdmin And (Not user.IsAdmin) Then Roles.RemoveUserFromRole(user.UserName, "Admin")
    End Sub

    <DataObjectMethod(DataObjectMethodType.Delete, True)>
    Public Sub DeleteUserData(ByVal user As UserData)
        Membership.DeleteUser(user.UserName)
    End Sub
End Class
