﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel;
using System.Web.Security;
using System.Web.Profile;

namespace SelfAspNetCs.Chap08
{
    public class UserData
    {
        public String UserName { get; set; }
        public String MyName { get; set; }
        public String Email { get; set; }
        public bool IsAdmin { get; set; }

        [DataObjectMethod(DataObjectMethodType.Select, true)]
        public List<UserData> GetAllUserData() {
            var data = new List<UserData>();
            MembershipUserCollection users = Membership.GetAllUsers();
            foreach(MembershipUser user in users) {
                var datum = new UserData();
                datum.UserName = user.UserName;
                datum.MyName = (String)ProfileBase.Create(user.UserName).GetPropertyValue("MyName");
                datum.Email = user.Email;
                datum.IsAdmin = Roles.IsUserInRole(user.UserName, "Admin");
                data.Add(datum);
            }
            return data;
        }

        [DataObjectMethod(DataObjectMethodType.Update, true)]
        public void UpdateUserData(UserData user) {
            MembershipUser curUser = Membership.GetUser(user.UserName);
            curUser.Email = user.Email;
            Membership.UpdateUser(curUser);
            ProfileBase prof = ProfileBase.Create(user.UserName);
            prof.SetPropertyValue("MyName", user.MyName);
            prof.Save();
            bool bAdmin = Roles.IsUserInRole(user.UserName, "Admin");
            if(!bAdmin && user.IsAdmin) {
                Roles.AddUserToRole(user.UserName, "Admin");
            }
            if(bAdmin && !user.IsAdmin) {
                Roles.RemoveUserFromRole(user.UserName, "Admin");
            }
        }

        [DataObjectMethod(DataObjectMethodType.Delete, true)]
        public void DeleteUserData(UserData user) {
            Membership.DeleteUser(user.UserName);
        }
    }
}