﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Profile;

namespace SelfAspNetCs.Chap10
{
    [Designer(typeof(System.Web.UI.Design.ControlDesigner))]
    [DefaultProperty("ProfileName")]
    [ToolboxData("<{0}:ProfileLabel runat=server></{0}:ProfileLabel>")]
    public class ProfileLabel : Label
    {

        [Bindable(true)]
        [Category("Behavior")]
        [DefaultValue("")]
        [Localizable(true)]
        [Description("プロファイル名")]
        public String ProfileName {
            get {
                String s = (String)ViewState["ProfileName"];
                if(s == null) {
                    return String.Empty;
                } else {
                    return s;
                }
            }

            set {
                ViewState["ProfileName"] = value;
            }
        }

        [Browsable(false)]
        public override String Text {
            get {
                return "";
            }
        
            set {
                throw new NotSupportedException();
            }
        }

        protected override void RenderContents(HtmlTextWriter writer)
        {
            HttpContext cx = this.Context;
            if(cx != null) {
                ProfileBase prof = ProfileBase.Create(this.Context.User.Identity.Name);
                writer.Write(prof.GetPropertyValue(this.ProfileName));
            } else {
                writer.Write(String.Format("[{0}]", this.ID));
            }
        }
    }
}
