﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Configuration;
using System.Data.SqlClient;

namespace SelfAspNetCs.Chap11
{
    /// <summary>
    /// BookService の概要の説明です
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    [System.Web.Script.Services.ScriptService]
    public class BookService : System.Web.Services.WebService
    {

        [WebMethod]
        public Book GetBookByIsbn(String isbn)
        {
            var b = new Book();
            ConnectionStringSettings setting =
                ConfigurationManager.ConnectionStrings["SelfAsp"];
            using(var db = new SqlConnection(setting.ConnectionString)) {
                var comm = new SqlCommand("SELECT * FROM Book WHERE isbn=@isbn", db);
                comm.Parameters.AddWithValue("@isbn", isbn);
                db.Open();
                SqlDataReader reader = comm.ExecuteReader();
                if(reader.Read()) {
                    b.Isbn = reader["isbn"].ToString();
                    b.Title = reader["title"].ToString();
                    b.Price = Int32.Parse(reader["price"].ToString());
                    b.Publish = reader["publish"].ToString();
                    b.Published = reader["published"].ToString();
                }
            }
            return b;
        }
    }

    public class Book {
        public String Isbn { get; set; }
        public String Title { get; set; }
        public int Price { get; set; }
        public String Publish { get; set; }
        public String Published { get; set; }
    }
}
