﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using AjaxControlToolkit;
using System.Configuration;
using System.Data.SqlClient;
using System.Collections.Specialized;

namespace SelfAspNetCs.Chap11
{
    /// <summary>
    /// CascadingList の概要の説明です
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    [System.Web.Script.Services.ScriptService]
    public class CascadingList : System.Web.Services.WebService
    {

        [WebMethod]
        public  CascadingDropDownNameValue[] GetDropDownData(String knownCategoryValues, String category)
        {
            var list = new List<CascadingDropDownNameValue>();
            ConnectionStringSettings setting =
                ConfigurationManager.ConnectionStrings["SelfAsp"];
            using(var db = new SqlConnection(setting.ConnectionString)) {
                var comm = new SqlCommand();
                comm.Connection = db;
                switch(category) {
                    case "Publish" :
                        comm.CommandText = "SELECT DISTINCT publish ,publish AS p FROM Book ORDER BY publish";
                        break;
                    case "Title" :
                        StringDictionary dic = CascadingDropDown.ParseKnownCategoryValuesString(knownCategoryValues);
                        comm.CommandText = "SELECT isbn ,title FROM Book WHERE publish=@publish";
                        comm.Parameters.AddWithValue("@publish", dic["Publish"]);
                        break;
                }
                db.Open();
                SqlDataReader reader = comm.ExecuteReader();
                while(reader.Read()) {
                    var pv = new CascadingDropDownNameValue(reader.GetString(1), reader.GetString(0));
                    list.Add(pv);
                }
            }
            return list.ToArray();
        }
    }
}
